schema = {'info': {'title': 'Cog', 'version': '0.1.0'}, 'paths': {'/': {'get': {'summary': 'Root', 'responses': {'200': {'content': {'application/json': {'schema': {}}}, 'description': 'Successful Response'}}, 'operationId': 'root__get'}}, '/predictions': {'post': {'summary': 'Predict', 'responses': {'200': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/Response'}}}, 'description': 'Successful Response'}, '422': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/HTTPValidationError'}}}, 'description': 'Validation Error'}}, 'description': 'Run a single prediction on the model', 'operationId': 'predict_predictions_post', 'requestBody': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/Request'}}}}}}}, 'openapi': '3.0.2', 'components': {'schemas': {'Input': {'type': 'object', 'title': 'Input', 'required': ['image'], 'properties': {'jpeg': {'type': 'integer', 'title': 'Jpeg', 'default': 40, 'x-order': 3, 'description': 'scale factor, activated for JPEG Compression Artifact Reduction. Leave it as default or arbitrary if other tasks are selected'}, 'image': {'type': 'string', 'title': 'Image', 'format': 'uri', 'x-order': 0, 'description': 'input image'}, 'noise': {'allOf': [{'$ref': '#/components/schemas/noise'}], 'default': 15, 'x-order': 2, 'description': 'noise level, activated for Grayscale Image Denoising and Color Image Denoising. Leave it as default or arbitrary if other tasks are selected'}, 'task_type': {'allOf': [{'$ref': '#/components/schemas/task_type'}], 'default': 'Real-World Image Super-Resolution-Large', 'x-order': 1, 'description': 'Choose a task'}}}, 'noise': {'enum': [15, 25, 50], 'type': 'integer', 'title': 'noise', 'description': 'An enumeration.'}, 'Output': {'type': 'string', 'title': 'Output', 'format': 'uri'}, 'Status': {'enum': ['processing', 'succeeded', 'failed'], 'type': 'string', 'title': 'Status', 'description': 'An enumeration.'}, 'Request': {'type': 'object', 'title': 'Request', 'properties': {'input': {'$ref': '#/components/schemas/Input'}, 'output_file_prefix': {'type': 'string', 'title': 'Output File Prefix'}}, 'description': 'The request body for a prediction'}, 'Response': {'type': 'object', 'title': 'Response', 'required': ['status'], 'properties': {'error': {'type': 'string', 'title': 'Error'}, 'output': {'$ref': '#/components/schemas/Output'}, 'status': {'$ref': '#/components/schemas/Status'}}, 'description': 'The response body for a prediction'}, 'task_type': {'enum': ['Real-World Image Super-Resolution-Large', 'Real-World Image Super-Resolution-Medium', 'Grayscale Image Denoising', 'Color Image Denoising', 'JPEG Compression Artifact Reduction'], 'type': 'string', 'title': 'task_type', 'description': 'An enumeration.'}, 'ValidationError': {'type': 'object', 'title': 'ValidationError', 'required': ['loc', 'msg', 'type'], 'properties': {'loc': {'type': 'array', 'items': {'anyOf': [{'type': 'string'}, {'type': 'integer'}]}, 'title': 'Location'}, 'msg': {'type': 'string', 'title': 'Message'}, 'type': {'type': 'string', 'title': 'Error Type'}}}, 'HTTPValidationError': {'type': 'object', 'title': 'HTTPValidationError', 'properties': {'detail': {'type': 'array', 'items': {'$ref': '#/components/schemas/ValidationError'}, 'title': 'Detail'}}}}}}
model_id = 'jingyunliang/swinir'
model_version = '660d922d33153019e8c263a3bba265de882e7f4f70396546b6c9c8f9d47a021a'
model_info = {'hardware': 'Nvidia A100 (40GB) GPU'}
