schema = {'info': {'title': 'Cog', 'version': '0.1.0'}, 'paths': {'/': {'get': {'summary': 'Root', 'responses': {'200': {'content': {'application/json': {'schema': {'title': 'Response Root  Get'}}}, 'description': 'Successful Response'}}, 'operationId': 'root__get'}}, '/shutdown': {'post': {'summary': 'Start Shutdown', 'responses': {'200': {'content': {'application/json': {'schema': {'title': 'Response Start Shutdown Shutdown Post'}}}, 'description': 'Successful Response'}}, 'operationId': 'start_shutdown_shutdown_post'}}, '/predictions': {'post': {'summary': 'Predict', 'responses': {'200': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/PredictionResponse'}}}, 'description': 'Successful Response'}, '422': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/HTTPValidationError'}}}, 'description': 'Validation Error'}}, 'parameters': [{'in': 'header', 'name': 'prefer', 'schema': {'type': 'string', 'title': 'Prefer'}, 'required': False}], 'description': 'Run a single prediction on the model', 'operationId': 'predict_predictions_post', 'requestBody': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/PredictionRequest'}}}}}}, '/health-check': {'get': {'summary': 'Healthcheck', 'responses': {'200': {'content': {'application/json': {'schema': {'title': 'Response Healthcheck Health Check Get'}}}, 'description': 'Successful Response'}}, 'operationId': 'healthcheck_health_check_get'}}, '/predictions/{prediction_id}': {'put': {'summary': 'Predict Idempotent', 'responses': {'200': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/PredictionResponse'}}}, 'description': 'Successful Response'}, '422': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/HTTPValidationError'}}}, 'description': 'Validation Error'}}, 'parameters': [{'in': 'path', 'name': 'prediction_id', 'schema': {'type': 'string', 'title': 'Prediction ID'}, 'required': True}, {'in': 'header', 'name': 'prefer', 'schema': {'type': 'string', 'title': 'Prefer'}, 'required': False}], 'description': 'Run a single prediction on the model (idempotent creation).', 'operationId': 'predict_idempotent_predictions__prediction_id__put', 'requestBody': {'content': {'application/json': {'schema': {'allOf': [{'$ref': '#/components/schemas/PredictionRequest'}], 'title': 'Prediction Request'}}}, 'required': True}}}, '/predictions/{prediction_id}/cancel': {'post': {'summary': 'Cancel', 'responses': {'200': {'content': {'application/json': {'schema': {'title': 'Response Cancel Predictions  Prediction Id  Cancel Post'}}}, 'description': 'Successful Response'}, '422': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/HTTPValidationError'}}}, 'description': 'Validation Error'}}, 'parameters': [{'in': 'path', 'name': 'prediction_id', 'schema': {'type': 'string', 'title': 'Prediction ID'}, 'required': True}], 'description': 'Cancel a running prediction', 'operationId': 'cancel_predictions__prediction_id__cancel_post'}}}, 'openapi': '3.0.2', 'components': {'schemas': {'Input': {'type': 'object', 'title': 'Input', 'properties': {'seed': {'type': 'integer', 'title': 'Seed', 'default': -1, 'x-order': 8, 'description': 'Seed for different images and reproducibility. Use -1 to randomise seed'}, 'steps': {'type': 'integer', 'title': 'Steps', 'default': 25, 'maximum': 100, 'minimum': 1, 'x-order': 3, 'description': 'Number of inference steps'}, 'width': {'type': 'integer', 'title': 'Width', 'default': 512, 'x-order': 6, 'description': 'Width in pixels'}, 'frames': {'type': 'integer', 'title': 'Frames', 'default': 16, 'maximum': 32, 'minimum': 1, 'x-order': 5, 'description': 'Length of the video in frames (playback is at 8 fps e.g. 16 frames @ 8 fps is 2 seconds)'}, 'height': {'type': 'integer', 'title': 'Height', 'default': 512, 'x-order': 7, 'description': 'Height in pixels'}, 'prompt': {'type': 'string', 'title': 'Prompt', 'default': 'photo of vocano, rocks, storm weather, wind, lava waves, lightning, 8k uhd, dslr, soft lighting, high quality, film grain, Fujifilm XT3', 'x-order': 0}, 'base_model': {'allOf': [{'$ref': '#/components/schemas/base_model'}], 'default': 'realisticVisionV20_v20', 'x-order': 2, 'description': 'Select a base model (DreamBooth checkpoint)'}, 'output_format': {'allOf': [{'$ref': '#/components/schemas/output_format'}], 'default': 'mp4', 'x-order': 17, 'description': "Output format of the video. Can be 'mp4' or 'gif'"}, 'guidance_scale': {'type': 'number', 'title': 'Guidance Scale', 'default': 7.5, 'maximum': 20, 'minimum': 0, 'x-order': 4, 'description': 'Guidance Scale. How closely do we want to adhere to the prompt and its contents'}, 'negative_prompt': {'type': 'string', 'title': 'Negative Prompt', 'default': 'blur, haze, deformed iris, deformed pupils, semi-realistic, cgi, 3d, render, sketch, cartoon, drawing, anime, mutated hands and fingers, deformed, distorted, disfigured, poorly drawn, bad anatomy, wrong anatomy, extra limb, missing limb, floating limbs, disconnected limbs, mutation, mutated, ugly, disgusting, amputation', 'x-order': 1}, 'pan_up_motion_strength': {'type': 'number', 'title': 'Pan Up Motion Strength', 'default': 0, 'maximum': 1, 'minimum': 0, 'x-order': 13, 'description': 'Strength of Pan Up Motion LoRA. 0 disables the LoRA'}, 'zoom_in_motion_strength': {'type': 'number', 'title': 'Zoom In Motion Strength', 'default': 0, 'maximum': 1, 'minimum': 0, 'x-order': 9, 'description': 'Strength of Zoom In Motion LoRA. 0 disables the LoRA'}, 'pan_down_motion_strength': {'type': 'number', 'title': 'Pan Down Motion Strength', 'default': 0, 'maximum': 1, 'minimum': 0, 'x-order': 14, 'description': 'Strength of Pan Down Motion LoRA. 0 disables the LoRA'}, 'pan_left_motion_strength': {'type': 'number', 'title': 'Pan Left Motion Strength', 'default': 0, 'maximum': 1, 'minimum': 0, 'x-order': 11, 'description': 'Strength of Pan Left Motion LoRA. 0 disables the LoRA'}, 'zoom_out_motion_strength': {'type': 'number', 'title': 'Zoom Out Motion Strength', 'default': 0, 'maximum': 1, 'minimum': 0, 'x-order': 10, 'description': 'Strength of Zoom Out Motion LoRA. 0 disables the LoRA'}, 'pan_right_motion_strength': {'type': 'number', 'title': 'Pan Right Motion Strength', 'default': 0, 'maximum': 1, 'minimum': 0, 'x-order': 12, 'description': 'Strength of Pan Right Motion LoRA. 0 disables the LoRA'}, 'rolling_clockwise_motion_strength': {'type': 'number', 'title': 'Rolling Clockwise Motion Strength', 'default': 0, 'maximum': 1, 'minimum': 0, 'x-order': 15, 'description': 'Strength of Rolling Clockwise Motion LoRA. 0 disables the LoRA'}, 'rolling_anticlockwise_motion_strength': {'type': 'number', 'title': 'Rolling Anticlockwise Motion Strength', 'default': 0, 'maximum': 1, 'minimum': 0, 'x-order': 16, 'description': 'Strength of Rolling Anticlockwise Motion LoRA. 0 disables the LoRA'}}}, 'Output': {'type': 'array', 'items': {'type': 'string', 'format': 'uri'}, 'title': 'Output'}, 'Status': {'enum': ['starting', 'processing', 'succeeded', 'canceled', 'failed'], 'type': 'string', 'title': 'Status', 'description': 'An enumeration.'}, 'base_model': {'enum': ['realisticVisionV20_v20', 'lyriel_v16', 'majicmixRealistic_v5Preview', 'rcnzCartoon3d_v10', 'toonyou_beta3'], 'type': 'string', 'title': 'base_model', 'description': 'An enumeration.'}, 'WebhookEvent': {'enum': ['start', 'output', 'logs', 'completed'], 'type': 'string', 'title': 'WebhookEvent', 'description': 'An enumeration.'}, 'output_format': {'enum': ['mp4', 'gif'], 'type': 'string', 'title': 'output_format', 'description': 'An enumeration.'}, 'ValidationError': {'type': 'object', 'title': 'ValidationError', 'required': ['loc', 'msg', 'type'], 'properties': {'loc': {'type': 'array', 'items': {'anyOf': [{'type': 'string'}, {'type': 'integer'}]}, 'title': 'Location'}, 'msg': {'type': 'string', 'title': 'Message'}, 'type': {'type': 'string', 'title': 'Error Type'}}}, 'PredictionRequest': {'type': 'object', 'title': 'PredictionRequest', 'properties': {'id': {'type': 'string', 'title': 'Id'}, 'input': {'$ref': '#/components/schemas/Input'}, 'webhook': {'type': 'string', 'title': 'Webhook', 'format': 'uri', 'maxLength': 65536, 'minLength': 1}, 'created_at': {'type': 'string', 'title': 'Created At', 'format': 'date-time'}, 'output_file_prefix': {'type': 'string', 'title': 'Output File Prefix'}, 'webhook_events_filter': {'type': 'array', 'items': {'$ref': '#/components/schemas/WebhookEvent'}, 'default': ['start', 'output', 'logs', 'completed']}}}, 'PredictionResponse': {'type': 'object', 'title': 'PredictionResponse', 'properties': {'id': {'type': 'string', 'title': 'Id'}, 'logs': {'type': 'string', 'title': 'Logs', 'default': ''}, 'error': {'type': 'string', 'title': 'Error'}, 'input': {'$ref': '#/components/schemas/Input'}, 'output': {'$ref': '#/components/schemas/Output'}, 'status': {'$ref': '#/components/schemas/Status'}, 'metrics': {'type': 'object', 'title': 'Metrics'}, 'version': {'type': 'string', 'title': 'Version'}, 'created_at': {'type': 'string', 'title': 'Created At', 'format': 'date-time'}, 'started_at': {'type': 'string', 'title': 'Started At', 'format': 'date-time'}, 'completed_at': {'type': 'string', 'title': 'Completed At', 'format': 'date-time'}}}, 'HTTPValidationError': {'type': 'object', 'title': 'HTTPValidationError', 'properties': {'detail': {'type': 'array', 'items': {'$ref': '#/components/schemas/ValidationError'}, 'title': 'Detail'}}}}}}
model_id = 'zsxkib/animate-diff'
model_version = '269a616c8b0c2bbc12fc15fd51bb202b11e94ff0f7786c026aa905305c4ed9fb'
model_info = {'hardware': 'Nvidia A40 GPU'}
